// Heating water in the boiler
// Simulate the teperature of heated water in dependence 
//   on the heating u=0 no heating, u=1 maximum heating
// ----------------------------------------------------------
exec SCIHOME/ScIntro.sce, mode(0)

nd=200;                                 // length of simulation
a=.95;                                  // time constant of heating
b=.8;                                   // effect of heating
sd=.05;                                 // noise std
u=[zeros(1,20) ones(1:130) zeros(1,50)];// indicator of heating
y(1)=2;                                 // initial temperature

// SIMULATION LOOP
for t=2:nd
  y(t)=a*y(t-1)+b*u(t)+sd*rand(1,1,'n');
end

// Results
plot(1:nd,y,1:nd,u)
title('Time course of heating water')
legend('temperature','heating');
