// Estimation of discrete model
// - change the uncertainty of the simulated model (compare results)
exec("ScIntro.sce",-1),mode(0)

nd=100;
th=[.4 .6                     // model parameter 
    .7 .3];
//th=[.01 .99; .99 .01];        // alternative model parameter 
   
u=(rand(nd,1,'unif')>.2)+1;   // input

// SIMULATION
for t=1:nd
  y(t)=(rand(1,1,'unif')>th(u(t)))+1;  // output
end

// ESTIMATION
V=zeros(2,2);
for t=1:nd
  V(u(t),y(t))=V(u(t),y(t))+1; // update of statistics
end

// POINT ESTIMATES
disp('Simulated'),th
disp('Estimated')
Eth=V./(sum(V,2)*ones(1,2))    // estimate of parameter

// RESULTS
plot(1:nd,y,'.:',1:nd,u,'r.:')
set(gcf(),'position',[600 80 600 500])
set(gca(),"data_bounds",[1, nd, .9, 2.1])
title('Data for estimation')
