// Minimum variance control
// - control with inverted model 
// -----------------------------
exec SCIHOME/ScIntro.sce, mode(0)

nd=200;
b0=1; a1=.6; b1=.2; k=2;           // parameters (known)
u=zeros(1,nd);
y=zeros(1,nd);
y(1)=-5;                           // initial y
yr=sin(8*(1:nd)/nd);               // reference (should be followed)
ctrl=1;                            // 1...control, 0...u=0 (no control)

// Time loop
for t=2:nd
  if ctrl==1
  u(t)=1/b0*(yr(t)-a1*y(t-1)-b1*u(t-1)-k);   // controller (inverted 
  else u(t)=0; end                           //    model)
  y(t)=b0*u(t)+a1*y(t-1)+b1*u(t-1)+k+.1*rand(1,1,'n'); // simulation
end

// Results
s=2:nd;
scf(1);
plot(s,y(s),s,u(s),s,yr(s));
legend('y','u','yr');
set(gca(),'grid',[1 1])

// Tasks
// 1. minimal and nonminimal phase: b1=.2 a b1=1.2
// 2. compare controlled and noncontrolled system for a1=.6, a1=.96
// 3. try nonstable system a1=-.6
