// Estimation of a simple mixture
//
clc, clear, close, close      // clear all
[u,t,n]=file();               // find working directory
chdir(dirname(n(1)));         // set working directory
getd();

load simple.dat ct yt         // load of data (from SimpleMixSim)
nd=max(size(yt));             // length of data
nu=rand(2,1,'u');             // pointer-model statistics
al=nu/sum(nu);                // pointer-model parameter

V=list(); thE=list(); cvE=list();
thE(1)=[6;2];  // in simulation was 8,1    initial
thE(2)=[1;3];  // in simulation was 0,5      parameters
for j=1:2                    
  V(j)=[thE(j);1]*[thE(j);1]'; // initial inf. matrix
  cvE(j)=.1*eye(2,2);         // initial noise covariance
end
ka=rand(1,2,'u');             // data counter

// Time loop ===================================
  for t=1:nd  
    
  // computation of weights
  for j=1:2
    [xxx,mL(j)]=GaussN(yt(:,t),thE(j),cvE(j)); // proximity
  end
  mp=mL-max(mL);              // normalization
  m=exp(mp);                  // exponent
  w=m.*al; w=w/sum(w);        // component weights
  wt(:,t)=w;                  // store
  
  // recomputation of statistics (using weights)
  Ps=[yt(:,t);1];
  for j=1:2
    V(j)=V(j)+w(j)*Ps*Ps';
    ka(j)=ka(j)+w(j);
    
    // point estimates
    thE(j)=(inv(V(j)(3,3))*V(j)(3,1:2))';
    if t>50
      // in the beginning, cvE is fixed
      cvE(j)=(V(j)(1:2,1:2)-thE(j)*V(j)(3,1:2))/ka(j);
    end
  end
  nu=nu+w;                    // pointer-model statistics
  al=nu/sum(nu);              //   and parameter
  
  th1(:,t)=thE(1);            // stor for
  th2(:,t)=thE(2);            //   plot
end

//Results
scf(1);
plot(wt')

set(scf(2),'position',[800 100 500 600])
subplot(211),plot(th1')
subplot(212),plot(th2')

save estim.dat
